
/*
 * MGL graphics library
 * Copyright (C) 1999-2000, ing. Marek Gayer

 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.

 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdlib.h>
#include <string.h>

#include <mgl.h>

extern mglFont *mainFont;

static mglTexture *image, *texture;

#define MAX_POINT 16

int pointx [MAX_POINT];
int pointy [MAX_POINT];
int points [MAX_POINT];

void renderDescription (int x, int y, char *desc)
{
  mglSetTextureZoom (0.7f);
  mglSetTextureColors (mglBlue);

  mglPuts (mainFont, desc, x + 15, y + 200 - mainFont->h);
}


void renderPoints (int x, int y, char *desc)
{
  mglPointColor = mglPink;
  mglSmoothOn ();

  mglPointColor.r = 0.87; mglPointColor.g = 0.5; mglPointColor.b = 0.5; mglPointColor.a = 1;
  mglSetPointSize(5);
  mglDrawPoint(36, 66);

  mglPointColor.r = 0.87; mglPointColor.g = 0.5; mglPointColor.b = 0.93; mglPointColor.a = 1;
  mglSetPointSize(9);
  mglDrawPoint(66, 31);

  mglPointColor.r = 0.87; mglPointColor.g = 0.91; mglPointColor.b = 0.93; mglPointColor.a = 1;
  mglSetPointSize(8);
  mglDrawPoint(49, 124);

  mglPointColor.r = 0.81; mglPointColor.g = 0.91; mglPointColor.b = 0.19; mglPointColor.a = 1;
  mglSetPointSize(10);
  mglDrawPoint(76, 79);

  mglPointColor.r = 0.81; mglPointColor.g = 0.04; mglPointColor.b = 0.03; mglPointColor.a = 1;
  mglSetPointSize(4);
  mglDrawPoint(125, 38);

  mglPointColor.r = 0.81; mglPointColor.g = 0.04; mglPointColor.b = 0.56; mglPointColor.a = 1;
  mglSetPointSize(7);
  mglDrawPoint(127, 108);

  mglPointColor.r = 0.81; mglPointColor.g = 0.53; mglPointColor.b = 0.56; mglPointColor.a = 1;
  mglSetPointSize(3);
  mglDrawPoint(142, 69);

  mglPointColor.r = 0.05; mglPointColor.g = 0.94; mglPointColor.b = 0.09; mglPointColor.a = 1;
  mglSetPointSize(1);
  mglDrawPoint(158, 33);

  mglPointColor.r = 0.84; mglPointColor.g = 0.58; mglPointColor.b = 0.31; mglPointColor.a = 0.98;
  mglSetPointSize(5);
  mglDrawPoint(140, 146);

  mglSmoothOff ();

  mglPointColor.r = 0.3; mglPointColor.g = 0.78; mglPointColor.b = 0.88; mglPointColor.a = 1;
  mglSetPointSize(7);
  mglDrawPoint(93, 136);

  mglPointColor.r = 0.13; mglPointColor.g = 0.05; mglPointColor.b = 0.88; mglPointColor.a = 1;
  mglSetPointSize(3);
  mglDrawPoint(164, 96);

  mglPointColor.r = 0.15; mglPointColor.g = 0.82; mglPointColor.b = 0.22; mglPointColor.a = 0.98;
  mglSetPointSize(6);
  mglDrawPoint(127, 150);

  mglPointColor.r = 0.13; mglPointColor.g = 0.05; mglPointColor.b = 0.88; mglPointColor.a = 1;
  mglSetPointSize(2);
  mglDrawPoint(183, 63);

  mglPointColor.r = 0.13; mglPointColor.g = 0.05; mglPointColor.b = 0.88; mglPointColor.a = 1;
  mglSetPointSize(4);
  mglDrawPoint(101, 15);

  mglPointColor.r = 0.13; mglPointColor.g = 0.05; mglPointColor.b = 0.88; mglPointColor.a = 1;
  mglSetPointSize(10);
  mglDrawPoint(86, 52);

  mglPointColor.r = 0.13; mglPointColor.g = 0.05; mglPointColor.b = 0.88; mglPointColor.a = 1;
  mglSetPointSize(6);
  mglDrawPoint(26, 25);

  mglPointColor.r = 0.513; mglPointColor.g = 0.05; mglPointColor.b = 0.88; mglPointColor.a = 1;
  mglSetPointSize(3);
  mglDrawPoint(26, 117);

  mglPointColor.r = 0.13; mglPointColor.g = 1.0; mglPointColor.b = 0.88; mglPointColor.a = 1;
  mglSetPointSize(3);
  mglDrawPoint(176, 152);

  mglPointColor.r = 0.13; mglPointColor.g = 0.05; mglPointColor.b = 0.88; mglPointColor.a = 1;
  mglSetPointSize(3);
  mglDrawPoint(180, 124);

  mglSmoothOff ();

  renderDescription (x, y, desc);
}

void renderLines (int x, int y, char *desc)
{
  mglLineColor[0].r = 0.01; mglLineColor[0].g = 0.05; mglLineColor[0].b = 0.97; mglLineColor[0].a = 1;
  mglLineColor[1].r = 0.01; mglLineColor[1].g = 0.05; mglLineColor[1].b = 0.97; mglLineColor[1].a = 1;
  mglSetLineSize(5);
  mglDrawLine(x + 171, y + 141, x + 30, y + 38);

  mglSmoothOn ();
  mglLineColor[0].r = 0.28; mglLineColor[0].g = 0.59; mglLineColor[0].b = 0.9; mglLineColor[0].a = 1;
  mglLineColor[1].r = 0.28; mglLineColor[1].g = 0.59; mglLineColor[1].b = 0.9; mglLineColor[1].a = 1;
  mglSetLineSize(5);
  mglDrawLine(x + 16, y + 140, x + 175, y + 84);
  mglSmoothOff ();

  mglLineColor[0].r = 0.95; mglLineColor[0].g = 0.09; mglLineColor[0].b = 0.94; mglLineColor[0].a = 1;
  mglLineColor[1].r = 0.95; mglLineColor[1].g = 0.09; mglLineColor[1].b = 0.94; mglLineColor[1].a = 1;
  mglSetLineSize(10);
  mglDrawLine(x + 16, y + 125, x + 27, y + 48);

  mglLineColor[0].r = 0.28; mglLineColor[0].g = 0.59; mglLineColor[0].b = 0.9; mglLineColor[0].a = 1;
  mglLineColor[1].r = 0.28; mglLineColor[1].g = 0.59; mglLineColor[1].b = 0.9; mglLineColor[1].a = 1;
  mglSetLineSize(2);
  mglDrawLine(x + 73, y + 16, x + 185, y + 59);

  mglLineColor[0].r = 0.89; mglLineColor[0].g = 0.2; mglLineColor[0].b = 0.17; mglLineColor[0].a = 1;
  mglLineColor[1].r = 0.89; mglLineColor[1].g = 0.2; mglLineColor[1].b = 0.17; mglLineColor[1].a = 1;
  mglSetLineSize(1);
  mglDrawLine(x + 21, y + 163, x + 184, y + 190);
  mglSmoothOn ();
  mglDrawLine(x + 21, y + 153, x + 184, y + 180);
  mglSmoothOff ();

  renderDescription (x, y, desc);
}

void renderTriangles (int x, int y, char *desc)
{
  mglSetLineSize (3);

  mglTriangleColor[0].r = 0.98; mglTriangleColor[0].g = 0.07; mglTriangleColor[0].b = 0.08; mglTriangleColor[0].a = 1;
  mglTriangleColor[1].r = 0.98; mglTriangleColor[1].g = 0.07; mglTriangleColor[1].b = 0.08; mglTriangleColor[1].a = 1;
  mglTriangleColor[2].r = 0.98; mglTriangleColor[2].g = 0.07; mglTriangleColor[2].b = 0.08; mglTriangleColor[2].a = 1;
  mglSetLineSize(1);
  mglDrawTriangle(x + 100, y + 20, x + 12, y + 94, x + 98, y + 139);

  mglTriangleColor[0].r = 0.98; mglTriangleColor[0].g = 0.07; mglTriangleColor[0].b = 0.96; mglTriangleColor[0].a = 1;
  mglTriangleColor[1].r = 0.98; mglTriangleColor[1].g = 0.07; mglTriangleColor[1].b = 0.96; mglTriangleColor[1].a = 1;
  mglTriangleColor[2].r = 0.98; mglTriangleColor[2].g = 0.07; mglTriangleColor[2].b = 0.96; mglTriangleColor[2].a = 1;
  mglSetLineSize(1);
  mglDrawTriangle(x + 160, y + 23, x + 48, y + 142, x + 167, y + 172);

  mglTriangleColor[0].r = 0.02; mglTriangleColor[0].g = 0.07; mglTriangleColor[0].b = 0.96; mglTriangleColor[0].a = 1;
  mglTriangleColor[1].r = 0.02; mglTriangleColor[1].g = 0.07; mglTriangleColor[1].b = 0.96; mglTriangleColor[1].a = 1;
  mglTriangleColor[2].r = 0.02; mglTriangleColor[2].g = 0.07; mglTriangleColor[2].b = 0.96; mglTriangleColor[2].a = 1;
  mglSetLineSize(1);
  mglDrawTriangle(x + 68, y + 7, x + 12, y + 148, x + 161, y + 185);

  renderDescription (x, y, desc);
}

void renderRectangles (int x, int y, char *desc)
{
  mglSmoothOn ();
  mglSetRectangleColors (mglRed);
  mglSetLineSize(3);
  mglDrawRectangle(x + 25, y + 30, 100, 100);

  mglSmoothOff ();
  mglSetRectangleColors (mglBlue);
  mglSetLineSize(7);
  mglDrawRectangle(x + 61, y + 63, 120, 100);

  renderDescription (x, y, desc);
}

void renderFlat (int x, int y, char *desc)
{
  mglSetRectangleColors (mglCeleste);
  mglSetLineSize(1);
  mglDrawFilledRectangle(x + 17, y + 16, 122, 109);

  mglSetTriangleColors (mglPink);
  mglDrawFilledTriangle(x + 112, y + 21, x + 13, y + 150, x + 183, y + 132);

  mglTriangleColor[0].r = 0.61; mglTriangleColor[0].g = 0.65; mglTriangleColor[0].b = 0.91; mglTriangleColor[0].a = 1;
  mglSetTriangleColors (mglTriangleColor [0]);
  mglDrawFilledTriangle(x + 34, y + 31, x + 89, y + 171, x + 180, y + 89);

  renderDescription  (x, y, desc);
}

void renderSmooth (int x, int y, char *desc)
{
  mglRectangleColor[0] = mglWhite;
  mglRectangleColor[1] = mglWhite;
  mglRectangleColor[2] = mglBlack;
  mglRectangleColor[3] = mglBlack;

  mglSetLineSize(1);
  mglDrawFilledRectangle(x + 25, y + 25, 150, 150);

  mglTriangleColor[0].r = 0.99; mglTriangleColor[0].g = 1; mglTriangleColor[0].b = 0.97; mglTriangleColor[0].a = 1;
  mglTriangleColor[1].r = 0.06; mglTriangleColor[1].g = 0.07; mglTriangleColor[1].b = 0.97; mglTriangleColor[1].a = 1;
  mglTriangleColor[2].r = 0.99; mglTriangleColor[2].g = 0.07; mglTriangleColor[2].b = 0.97; mglTriangleColor[2].a = 1;
  mglDrawFilledTriangle(x + 160, y + 160, x + 40, y + 105, x + 125, y + 40);

  renderDescription (x, y, desc);
}

void renderAlpha (int x, int y, char *desc)
{
  mglColor c;

  mglAlphaOn ();

  c = mglCeleste;
  mglSetTriangleColors (c);
  mglDrawFilledTriangle (x + 80, y + 15, x + 20, y + 135, x + 140, y + 135);

  c = mglPink;
  c.a = 0.333;
  mglSetRectangleColors (c);
  mglDrawFilledRectangle (x + 60, y + 75, 100, 100);

  renderDescription (x, y, desc);
}

static float angle;

void renderRotate (int x, int y, char *desc)
{
  int i;
  mglColor c;

  c = mglBlue;

  mglSmoothOn ();

  mglSetLineSize (3);

  if (mglFps)
  {
    angle += (float)30 / mglFps;
    if (angle > 360)
      angle -= 360;
  }

  for (i = 0; i < 90-15; i += 15)
  {
    mglRotationAngle = angle + i;
    c.a = 1 - (float) i/90;
    mglSetRectangleColors (c);
    mglDrawRectangle (x + 50, y + 50, 100, 100);
  }
  mglRotationAngle = 0;
  mglSmoothOff ();

  renderDescription (x, y, desc);
}

void renderImages (int x, int y, char *desc)
{
  mglSetTextureColors (mglWhite);
  mglSetTextureZoom (1);
  mglDrawTexture (image, x + 36, y + 36);
  renderDescription (x, y, desc);
}

void renderTextures (int x, int y, char *desc)
{
  mglColor c;

  c = mglWhite;
  c.a = 0.333;

  mglSetTextureZoom (1);
  mglSetTextureColors (c);
  mglDrawTexturedRectangle (texture, x+5, y+5, 190, 190);

  mglSetTextureColors (mglWhite);
  mglRotationAngle = 13.3;
  mglSetTextureZoom (0.333);
  mglDrawTexturedRectangle (texture, x + 25, y + 25, 150, 150);
  mglSetTextureZoom (1);
  mglRotationAngle = 0;
  renderDescription (x, y, desc);
}

void renderFonts (int x, int y, char *desc)
{
  mglSetTextureZoom (0.7);
  mglSetTextureColors (mglPink);
  mglPuts (mainFont, "!\"#$%&'()*+,-./0\n"
                  "\a2123456789:;<=>?@\n"
                  "\a3ABCDEFGHIJKLMNOP\n"
                  "\a4QRSTUVWXYZ[\\]^_'\n"
                  "\a7abcdefghijklmnop\n"
                  "\a8qrstuvwxyz{|}~\n", x+12, y+20);
  mglSetTextureZoom (1);

  renderDescription (x, y, desc);
}

void renderMore (int x, int y, char *desc)
{
  mglSetTextureZoom (0.7);
  mglSetTextureColors (mglBlack);
  mglPuts (mainFont,
    "\a2*\a0 Window\n  management\n"
    "\a2*\a0 Keyboard and\n"
    "  mouse input\n"
    "  handling\n"
    "\a2*\a0 Timer\n  functions", x+12, y+20);
  mglSetTextureZoom (1);

  renderDescription (x, y, desc);
}




void drawBars (void)
{
  mglSetLineColors (mglCeleste);
  mglSetLineSize (10);

  mglDrawLine (200, 0, 200, 600);
  mglDrawLine (400, 0, 400, 600);
  mglDrawLine (600, 0, 600, 600);

  mglDrawLine (0, 200, 800, 200);
  mglDrawLine (0, 400, 800, 400);

  mglSetLineSize (5);
  mglDrawLine (798, 0, 798, 600);
  mglDrawLine (0, 2, 800, 2);
  mglDrawLine (0, 598, 800, 598);
  mglDrawLine (2, 0, 2, 600);
}

void firstDisplay (void)
{
  mglSetTextureColors (mglWhite);
  mglClearScreen (mglWhite);

  drawBars ();
  renderPoints (0, 0, "Points");
  renderLines (200, 0, "Lines");
  renderTriangles (400, 0, "Triangles");
  renderRectangles (600, 0, "Rectangles");
  renderFlat (0, 200, "Color filling");
  renderSmooth (200, 200, "Interpolation");
  renderAlpha (400, 200, "Alpha Blending");
  renderRotate (600, 200, "Rotation");

  renderImages (0, 400, "Image formats");
  renderTextures (200, 400, "Textures");
  renderFonts (400, 400, "Fonts");
  renderMore (600, 400, "Other features");
}


void firstInit (void)
{
  angle = 0;

  if (!image)
  {
    image = mglLoadTexture ("../data/demo/rose.tga", 0, GL_LINEAR);
    texture = mglLoadTexture ("../data/demo/opengl.tga", 0, GL_LINEAR);
  }
}
