//***************************************************************************
// MGLDraw 1.0
// (c) 2000 Emil Aubrecht
//***************************************************************************

// Borland C++ Builder specific
#include <stdlib.h>

//---------------------------------------------------------------------------

#include <mgl.h>
#include "kresleni.h"
#include "gui.h"
#include "seznam.cpp"
//---------------------------------------------------------------------------

// seznam elementu
TSeznam<TElement> *elementy;

// seznam ovladani
TSeznam<TView> *ovladani;

//editovany element
TElement *elem;

// pouzity font
mglFont *mainFont;

//velikosti obrazu
int obrx=640, obry=480,
    virtx=800, virty=600;
bool fullscr = false;

// kurzor mysi pro celoobrazovkove mody
mglTexture *mouseImg;
bool showKurzor;

// nastaveni vzhledu

// pocet pracovnich bodu, aktivni bod, maximalni pocet pracovnich bodu
int bpocet = -1, bpos = -1, bmax = 0;

// souradnice tri bodu mysiho kliknuti
int mx[3], my[3];
int msize=3;
bool mfill=false;

mglColor mbarva[3];

// cislo ukladaneho souboru
int saveCount=0;

//---------------------------------------------------------------------------
bool showFps = true;

class ToknoFps: public TWindow {
  public:
    ToknoFps(int x, int y, int w, int h);
    virtual void DrawSpecial();
};

ToknoFps::ToknoFps(int x, int y, int w, int h): TWindow(x, y, w, h){
};

void ToknoFps::DrawSpecial() {

  mglShowFPS(mainFont, x+2+w, y+2);
};

ToknoFps *oknoFps = new ToknoFps(100, 0, 100, 30);
//---------------------------------------------------------------------------

bool showXY = true;
char xstr[10], ystr[10];

class ToknoXY: public TWindow {
  public:
    ToknoXY(int x, int y, int w, int h);
    virtual void DrawSpecial();
};

ToknoXY::ToknoXY(int x, int y, int w, int h): TWindow(x, y, w, h){
};

void ToknoXY::DrawSpecial() {

  sprintf(xstr, "X=%4d", (int) mglMouseX);
  sprintf(ystr, "Y=%4d", (int) mglMouseY);
  mglPuts(mainFont, xstr, x+2, y+2);
  mglPuts(mainFont, ystr, x+2, y+22 );
};

ToknoXY *oknoXY = new ToknoXY(100, 0, 100, 50);
//---------------------------------------------------------------------------

bool showInfo = true;
char infoStr[] = "\a5      MGLDraw 1.0\a0\n"
                 "grafick editor pro MGL\n"
                 "(c) 2000 Emil Aubrecht\n\n"
                 "\a2F1\a0  klvesy on/off\n"
                 "\a2F2\a0  nstroje on/off\n"
                 "\a2F3\a0  editace on/off\n"
                 "\a2F4\a0  paleta on/off\n"
                 "\a2F5\a0  vpis FPS on/off\n"
                 "\a2F6\a0  souadnice on/off\n"
                 "\a2F10\a0 kurzor myi on/off";

class ToknoInfo: public TWindow {
  public:
    ToknoInfo(int x, int y, int w, int h);
    virtual void DrawSpecial();
};

ToknoInfo::ToknoInfo(int x, int y, int w, int h): TWindow(x, y, w, h){
};

void ToknoInfo::DrawSpecial() {

  mglPuts(mainFont, infoStr, x+2, y+2);
};

ToknoInfo *oknoInfo = new ToknoInfo(0, 0, 400, 270);
//---------------------------------------------------------------------------

// je okno nastroju zobrazeno
bool showNastroj = true;

// kreslici nastroj
#define NPOCET 5
enum TNastroj {NASTROJ_BOD = 0, NASTROJ_CARA, NASTROJ_TROJUHELNIK, NASTROJ_OBDELNIK,
               NASTROJ_EDITACE};
TNastroj nastroj = NASTROJ_BOD;

void NastavNastroj(int anastroj);

char napisy[NPOCET][20] = { "Point", "Line", "Triangle", "Rectangle", "EDITACE"};

class ToknoNastroj: public TWindow {
  public:
    ToknoNastroj(int x, int y, int w, int h);
    virtual void DrawSpecial();
    virtual bool HandleEventSpecial(int event);
};

ToknoNastroj::ToknoNastroj(int x, int y, int w, int h): TWindow(x, y, w, h){
};

void ToknoNastroj::DrawSpecial() {
  int i;

  mglSetRectangleColors(mglRed);
  mglDrawFilledRectangle(x+4, y+6+(int)nastroj*20, w-8, 20);

  for(i=0; i<NPOCET; i++)
    mglPuts(mainFont, napisy[i], x+4, y+4+i*20);

};

bool ToknoNastroj::HandleEventSpecial(int event) {

  if (event == MGL_LEFT_BUTTON_DOWN) {
    NastavNastroj((TNastroj)((int)mglMouseY-y-6)/20);
    return true;
  };
  return false;
};

ToknoNastroj *oknoNastroj = new ToknoNastroj(0, 0, 160, 110);
//---------------------------------------------------------------------------
// je okno editace vlastnosti zobrazeno
bool showEdit = true;
char xestr[20], yestr[20], sizestr[20];

bool showEditInfo = true;

// editovany element
TNastroj enastroj;

int cisloelementu = 0;

class ToknoEdit: public TWindow {
  public:
    ToknoEdit(int x, int y, int w, int h);
    virtual void DrawSpecial();
    virtual bool HandleEventSpecial(int event);
};

ToknoEdit::ToknoEdit(int x, int y, int w, int h): TWindow(x, y, w, h){
};

mglColor vybrano = {1.0, 1.0 ,0.0 ,0.2};

mglColor barvaPaleta = {0.5, 0.5, 0.5, 1.0};

void ToknoEdit::DrawSpecial() {

  if ((nastroj!=NASTROJ_EDITACE)||(bpocet > -1))
    mglPuts(mainFont, napisy[(int)enastroj], x+4, y+4);

  if (!elem)
    return;
  if (!showEditInfo)
    return;

  switch(enastroj) {
    case NASTROJ_TROJUHELNIK:
      if (bpocet > 1) {
        sprintf(xestr, "X3=%4d", mx[2]);
        sprintf(yestr, "Y3=%4d", my[2]);

        mglRectangleColor[0] = mbarva[2];
        mglRectangleColor[1] = mbarva[2];
        mglRectangleColor[2] = mbarva[2];
        mglRectangleColor[3] = mbarva[2];
        mglDrawFilledRectangle(x+w-30, y+124, 20, 40);
      } else {
          sprintf(xestr, "X3=");
          sprintf(yestr,"Y3=");
        };
      mglPuts(mainFont, xestr, x+4, y+124);
      mglPuts(mainFont, yestr, x+4, y+144);
    case NASTROJ_CARA:
    case NASTROJ_OBDELNIK:
      if (bpocet > 0) {
        sprintf(xestr, "X2=%4d", mx[1]);
        sprintf(yestr, "Y2=%4d", my[1]);

        mglRectangleColor[0] = mbarva[1];
        mglRectangleColor[1] = mbarva[1];
        mglRectangleColor[2] = mbarva[1];
        mglRectangleColor[3] = mbarva[1];
        mglDrawFilledRectangle(x+w-30, y+84, 20, 40);
      } else {
          sprintf(xestr, "X2=");
          sprintf(yestr,"Y2=");
        };
      mglPuts(mainFont, xestr, x+4, y+84);
      mglPuts(mainFont, yestr, x+4, y+104);
    case NASTROJ_BOD:
      if (bpocet > -1) {
        sprintf(xestr, "X1=%4d", mx[0]);
        sprintf(yestr, "Y1=%4d", my[0]);

        mglRectangleColor[0] = mbarva[0];
        mglRectangleColor[1] = mbarva[0];
        mglRectangleColor[2] = mbarva[0];
        mglRectangleColor[3] = mbarva[0];
        mglDrawFilledRectangle(x+w-30, y+44, 20, 40);
      } else {
          sprintf(xestr, "X1=");
          sprintf(yestr,"Y1=");
        };

      mglPuts(mainFont, xestr, x+4, y+44);
      mglPuts(mainFont, yestr, x+4, y+64);

      break;
    default:
      break;
  };
  switch(enastroj) {
    case NASTROJ_TROJUHELNIK:
      mfill ? sprintf(sizestr, "fill=\a5on\a0") : sprintf(sizestr, "fill=\a5off\a0");
      break;
    case NASTROJ_CARA:
      sprintf(sizestr, "\a5<\a0width=%2d\a5>\a0", msize);
      break;
    case NASTROJ_OBDELNIK:
      mfill ? sprintf(sizestr, "fill=\a5on\a0") : sprintf(sizestr, "fill=\a5off\a0");
      break;
    case NASTROJ_BOD:
      sprintf(sizestr, "\a5<\a0size=%2d\a5>\a0", msize);
      break;
  };

  if (nastroj == NASTROJ_EDITACE) {
    mglRectangleColor[0] = vybrano;
    mglRectangleColor[1] = vybrano;
    mglRectangleColor[2] = vybrano;
    mglRectangleColor[3] = vybrano;
    mglDrawFilledRectangle(x+4, y+44+bpos*40 , w-42, 40);
  };

  mglPuts(mainFont, sizestr, x+4, y+24);
};

void SetMX(bool styl); // forward

bool ToknoEdit::HandleEventSpecial(int event) {

  if (event == MGL_LEFT_BUTTON_DOWN) {

    if ((y+24 < mglMouseY) && (mglMouseY< y+44)) {

      if ((x+4 <= mglMouseX) && (mglMouseX <= x+w/2)) {
        if (msize > 1)
          msize-=1;
        mfill = !mfill;
        if (nastroj ==NASTROJ_EDITACE)
         switch(enastroj) {
          case NASTROJ_BOD:
            ((TElementBod*)elem)->SetSirka(msize);
            break ;
          case NASTROJ_CARA:
            ((TElementCara*)elem)->SetSirka(msize);
            break ;
          case NASTROJ_TROJUHELNIK:
            ((TElementTrojuhelnik*)elem)->SetVyplneny(mfill);
            break ;
          case NASTROJ_OBDELNIK:
            ((TElementObdelnik*)elem)->SetVyplneny(mfill);
            break ;
        };
      };
      if ((x+w/2 <= mglMouseX) && (mglMouseX <= x+w-4)) {
        if (msize < mglMaxPointSize)
        msize+=1; mfill = !mfill;
        if (nastroj ==NASTROJ_EDITACE)
         switch(enastroj) {
          case NASTROJ_BOD:
            ((TElementBod*)elem)->SetSirka(msize);
            break ;
          case NASTROJ_CARA:
            ((TElementCara*)elem)->SetSirka(msize);
            break ;
          case NASTROJ_TROJUHELNIK:
            ((TElementTrojuhelnik*)elem)->SetVyplneny(mfill);
            break ;
          case NASTROJ_OBDELNIK:
            ((TElementObdelnik*)elem)->SetVyplneny(mfill);
            break ;
        };
      };
    };
    if ((y+44 < mglMouseY) && (mglMouseY< y+84)) {
      if ((x+4 <= mglMouseX) && (mglMouseX <= x+w-42))
        bpos = 0;
      if ((x+w-42 <= mglMouseX) && (mglMouseX <= x+w)) {
        mbarva[0] = barvaPaleta;
        SetMX(false);
      };
    };
    if ((y+84 < mglMouseY) && (mglMouseY< y+124)) {
      if ((x+4 <= mglMouseX) && (mglMouseX <= x+w-42))
        if (enastroj != NASTROJ_BOD)
          bpos = 1;
      if ((x+w-42 <= mglMouseX) && (mglMouseX <= x+w)) {
        mbarva[1] = barvaPaleta;
        SetMX(false);
      };
    };
    if ((y+124 < mglMouseY) && (mglMouseY< y+164)) {
      if ((x+4 <= mglMouseX) && (mglMouseX <= x+w-42))
        if (enastroj == NASTROJ_TROJUHELNIK)
        bpos = 2;
      if ((x+w-42 <= mglMouseX) && (mglMouseX <= x+w)) {
        mbarva[2] = barvaPaleta;
        SetMX(false);
      };
    };
    return true;
  };
  return false;
};

ToknoEdit *oknoEdit = new ToknoEdit(160, 0, 160, 170);
//---------------------------------------------------------------------------

mglColor seda = {0.5, 0.5, 0.5, 1};

bool showPaleta = true;

class ToknoPaleta: public TWindow {
  public:
    ToknoPaleta(int x, int y, int w, int h);
    virtual void DrawSpecial();
    virtual bool HandleEventSpecial(int event);
};

ToknoPaleta::ToknoPaleta(int x, int y, int w, int h): TWindow(x, y, w, h){

  pozadiOn = false;
};

void ToknoPaleta::DrawSpecial() {

  mglRectangleColor[0] = mglBlack;
  mglRectangleColor[1] = mglRed;
  mglRectangleColor[2] = mglRed;
  mglRectangleColor[3] = mglBlack;
  mglDrawFilledRectangle(x+4, y+4, w-8, 20);

  mglRectangleColor[0] = mglBlack;
  mglRectangleColor[1] = mglGreen;
  mglRectangleColor[2] = mglGreen;
  mglRectangleColor[3] = mglBlack;
  mglDrawFilledRectangle(x+4, y+24, w-8, 20);

  mglRectangleColor[0] = mglBlack;
  mglRectangleColor[1] = mglBlue;
  mglRectangleColor[2] = mglBlue;
  mglRectangleColor[3] = mglBlack;
  mglDrawFilledRectangle(x+4, y+44, w-8, 20);

  // alpha
  mglRectangleColor[0] = mglBlack;
  mglRectangleColor[1] = seda;
  mglRectangleColor[2] = seda;
  mglRectangleColor[3] = mglBlack;
  mglDrawFilledRectangle(x+4, y+64, w-8, 20);

  // vzorek
  mglRectangleColor[0] = barvaPaleta;
  mglRectangleColor[1] = barvaPaleta;
  mglRectangleColor[2] = barvaPaleta;
  mglRectangleColor[3] = barvaPaleta;
  mglDrawFilledRectangle(x+10, y+90, w-20, 22);

  mglRectangleColor[0] = mglWhite;
  mglRectangleColor[1] = mglWhite;
  mglRectangleColor[2] = mglWhite;
  mglRectangleColor[3] = mglWhite;
  mglDrawFilledRectangle(x+3+barvaPaleta.r*(w-8), y+5, 2, 18);
  mglDrawFilledRectangle(x+3+barvaPaleta.g*(w-8), y+25, 2, 18);
  mglDrawFilledRectangle(x+3+barvaPaleta.b*(w-8), y+45, 2, 18);
  mglDrawFilledRectangle(x+3+barvaPaleta.a*(w-8), y+65, 2, 18);
};

bool ToknoPaleta::HandleEventSpecial(int event) {

  if (event == MGL_LEFT_BUTTON_DOWN) {
    if ((x+4 <= mglMouseX) && (mglMouseX <= x+w-4)) {
      if ((y+4 < mglMouseY) && (mglMouseY< y+24))
        barvaPaleta.r = 1.0*(mglMouseX-x-4)/(w-8);
      if ((y+24 < mglMouseY) && (mglMouseY< y+44))
        barvaPaleta.g = 1.0*(mglMouseX-x-4)/(w-8);
      if ((y+44 < mglMouseY) && (mglMouseY< y+64))
        barvaPaleta.b = 1.0*(mglMouseX-x-4)/(w-8);
      if ((y+64 < mglMouseY) && (mglMouseY< y+84))
        barvaPaleta.a = 1.0*(mglMouseX-x-4)/(w-8);
    };
    return true;
  };
  return false;
};

ToknoPaleta *oknoPaleta = new ToknoPaleta(0, 0, 108, 120);
//---------------------------------------------------------------------------

void RefreshMX() {
  int pom;

  showEditInfo = false;
  pom = bpocet; bpocet = -1;

  if (!elem)
    return;

  if (cisloelementu == 0)
    return;
  elem = elementy->DejPrvek(cisloelementu-1);

  showEditInfo = true;
  bpocet = pom;

  enastroj = (TNastroj)elem->GetTyp();
  switch (enastroj) {
    case NASTROJ_BOD:
      ((TElementBod*)elem)->GetXY(mx[0], my[0]);
      ((TElementBod*)elem)->GetBarva(mbarva);
      msize = ((TElementBod*)elem)->GetSirka();
      bmax = 0; bpocet = 0; bpos = 0;
    break;
    case NASTROJ_CARA:
      ((TElementCara*)elem)->GetXY1(mx[0], my[0]);
      ((TElementCara*)elem)->GetXY2(mx[1], my[1]);
      ((TElementCara*)elem)->GetBarva(mbarva);
      msize = ((TElementCara*)elem)->GetSirka();
      bmax = 1; bpocet = 1; bpos = 0;
    break;
    case NASTROJ_TROJUHELNIK:
      ((TElementTrojuhelnik*)elem)->GetXY1(mx[0], my[0]);
      ((TElementTrojuhelnik*)elem)->GetXY2(mx[1], my[1]);
      ((TElementTrojuhelnik*)elem)->GetXY3(mx[2], my[2]);
      ((TElementTrojuhelnik*)elem)->GetBarva(mbarva);
      mfill = ((TElementTrojuhelnik*)elem)->GetVyplneny();
      bmax = 2; bpocet = 2; bpos = 0;
    break;
    case NASTROJ_OBDELNIK:
      ((TElementObdelnik*)elem)->GetXY1(mx[0], my[0]);
      ((TElementObdelnik*)elem)->GetXY2(mx[1], my[1]);
      ((TElementObdelnik*)elem)->GetBarva(mbarva);
      mx[1] = mx[1]+ mx[0];
      my[1] = my[1]+ my[0];
      mfill = ((TElementObdelnik*)elem)->GetVyplneny();
      bmax = 1; bpocet = 1; bpos = 0;
    break;
  };
};
//---------------------------------------------------------------------------

void SetMX(bool styl) {

  if (!elem)
    return;

  switch (enastroj) {
    case NASTROJ_BOD:
      if (styl)
        ((TElementBod*)elem)->SetXY(mx[0], my[0]);
      else
        ((TElementBod*)elem)->SetBarva(mbarva);
    break;
    case NASTROJ_CARA:
      if (styl) {
        ((TElementCara*)elem)->SetXY1(mx[0], my[0]);
        ((TElementCara*)elem)->SetXY2(mx[1], my[1]);
      } else
          ((TElementCara*)elem)->SetBarva(mbarva);
    break;
    case NASTROJ_TROJUHELNIK:
      if (styl) {
        ((TElementTrojuhelnik*)elem)->SetXY1(mx[0], my[0]);
        ((TElementTrojuhelnik*)elem)->SetXY2(mx[1], my[1]);
        ((TElementTrojuhelnik*)elem)->SetXY3(mx[2], my[2]);
      } else
          ((TElementTrojuhelnik*)elem)->SetBarva(mbarva);
    break;
    case NASTROJ_OBDELNIK:
      if (styl) {
        ((TElementObdelnik*)elem)->SetXY1(mx[0], my[0]);
        ((TElementObdelnik*)elem)->SetXY2(mx[1]-mx[0], my[1]-my[0]);
      } else
        ((TElementObdelnik*)elem)->SetBarva(mbarva);
    break;
  };
};
//---------------------------------------------------------------------------

void NastavNastroj(int anastroj) {
  switch(anastroj) {
    case 0:
      nastroj = NASTROJ_BOD;
      enastroj = nastroj;
      showEditInfo = true;
      bmax = 0; bpocet = -1; bpos = -1; break;
    case 1:
      nastroj = NASTROJ_CARA;
      enastroj = nastroj;
      showEditInfo = true;
      bmax = 1; bpocet = -1; bpos = -1; break;
    case 2:
      nastroj = NASTROJ_TROJUHELNIK;
      enastroj = nastroj;
      showEditInfo = true;
      bmax = 2; bpocet = -1; bpos = -1; break;
    case 3:
      nastroj = NASTROJ_OBDELNIK;
      enastroj = nastroj;
      showEditInfo = true;
      bmax = 1; bpocet = -1; bpos = -1; break;
    case 4:
      nastroj = NASTROJ_EDITACE;
      if ((cisloelementu == 0) && (elementy->PocetPrvku()>0))
        cisloelementu = 1;
      RefreshMX();
      break;
    default: break;
  };
};
//---------------------------------------------------------------------------

// ulozeni do souboru
void Save() {
  FILE *soubor;
  TElement *pom;
  char jmeno[20];

  sprintf(jmeno, "save%03i.c", saveCount);

  //otevreni souboru pro zapis
  soubor = fopen(jmeno, "wt");
  if (!soubor)
    return;

  fprintf(soubor, "void drawScene%03i (int x, int y)\n{\n", saveCount);

  // ulozeni jednotlivych elementu
  if (elementy) {
    elementy->NaZacatek();
    while ((pom = elementy->CtiPrvek()) != NULL) {
      pom->Save(soubor);
      elementy->Posun();
    };
  };

  fprintf(soubor, "};\n");

  // uzavreni souboru
  fclose(soubor);

  saveCount++;
};
//---------------------------------------------------------------------------
// zobrazeni
void ZobrazovaciFce(void) {
  TElement *pom;
  TView *pomw;
  int i;

  mglClearScreen(mglBlack);

  // zobrazeni vsech elementu
  if (elementy) {
    elementy->NaZacatek();
    while ((pom = elementy->CtiPrvek()) != NULL) {
      pom->Zobraz();
      elementy->Posun();
    };
  };

  // zobrazeni vsech oken
  if (ovladani) {
    ovladani->NaZacatek();
    while ((pomw = ovladani->CtiPrvek()) != NULL) {
      pomw->Draw();
      ovladani->Posun();
    };
  };

  mglSetLineSize (2);
  for(i = 0; i <= bpocet; i++) {
    // aktivni bod
    if (i == bpos) {
      mglLineColor [0] = mglRed;
      mglLineColor [1] = mglRed;
    }
    else {
      mglLineColor [0] = mglGreen;
      mglLineColor [1] = mglGreen;
    };
    mglDrawLine(mx[i]-7, my[i]-7, mx[i]+7, my[i]+7);
    mglDrawLine(mx[i]-7, my[i]+7, mx[i]+7, my[i]-7);
  };

  // zobrazeni kurzoru
  if (showKurzor)
  {
    mglSetTextureZoom (0.5);
    mglDrawTexture(mouseImg, mglMouseX, mglMouseY);
    mglSetTextureZoom (1.0);
  }
}
//------------------------------------------------------------------------------

void HandlovaniKlaves(int key) {
  TElement *el;

  switch (key) {
    case 27:
      exit (0);
      break;
    case 'p':
      NastavNastroj(0);
      break;
    case 'l':
      NastavNastroj(1);
      break;
    case 't':
      NastavNastroj(2);
      break;
    case 'r':
      NastavNastroj(3);
      break;
    case 'e':
      NastavNastroj(4);
      break;

    case 's':
      Save();
      break;

    case MGL_KEY_F1:
      showInfo = !showInfo;
      if (showInfo)
        oknoInfo->Show();
      else
        oknoInfo->Hide();
      break;

    case MGL_KEY_F2:
      showNastroj = !showNastroj;
      if (showNastroj)
        oknoNastroj->Show();
      else
        oknoNastroj->Hide();
      break;

    case MGL_KEY_F3:
      showEdit = !showEdit;
      if (showEdit)
        oknoEdit->Show();
      else
        oknoEdit->Hide();
      break;

    case MGL_KEY_F4:
      showPaleta = !showPaleta;
      if (showPaleta)
        oknoPaleta->Show();
      else
        oknoPaleta->Hide();
      break;

    case MGL_KEY_F5:
      showFps = !showFps;
      if (showFps)
        oknoFps->Show();
      else
        oknoFps->Hide();
      break;

    case MGL_KEY_F6:
      showXY = !showXY;
      if (showXY)
        oknoXY->Show();
      else
        oknoXY->Hide();
      break;

    case MGL_KEY_F10:
      showKurzor = !showKurzor;
      break;

    case MGL_KEY_PAGE_UP:
      if (nastroj != NASTROJ_EDITACE)
        NastavNastroj(4);
      if (cisloelementu>1)
        cisloelementu--;
      else
        if (elementy->PocetPrvku()>0)
          cisloelementu = 1;

      RefreshMX();

      break;

    case MGL_KEY_PAGE_DOWN:
      if (nastroj != NASTROJ_EDITACE)
        NastavNastroj(4);
      if (cisloelementu+1<=elementy->PocetPrvku()) {
        cisloelementu++;
        RefreshMX();
      };
      break;

    case 127: // DELETE
      if ((el = elementy->DejPrvek(cisloelementu-1)) != NULL) {
        elementy->Odeber(el);
        if (cisloelementu == elementy->PocetPrvku()+1)
          cisloelementu--;
        RefreshMX();
      };
      break;
    default:
      break;
  };
};
//------------------------------------------------------------------------------

void ObsluhaMysi(int event) {
  TElementBod *pomb;
  TElementCara *pom;
  TElementTrojuhelnik *pomt;
  TElementObdelnik *pomo;

  TView *pomw;
  bool obslouzena;

  // obsluha udalosti v oknech
  obslouzena = false;
  if (ovladani) {
    ovladani->NaZacatek();
    while ((pomw = ovladani->CtiPrvek()) != NULL) {
      if (pomw->HandleEvent(event)) {
        obslouzena = true;
        break;
      };
      ovladani->Posun();
    };
  };

 if (!obslouzena)
  switch (event) {
    case MGL_LEFT_BUTTON_DOWN:
      if (nastroj != NASTROJ_EDITACE) {
        bpocet++;
        bpos++;
      mbarva[bpos] = barvaPaleta;
      };
      mx[bpos] = mglMouseX;
      my[bpos] = mglMouseY;
      if (nastroj == NASTROJ_EDITACE) {
        SetMX(true);
        break;
      };
      if (bpocet == bmax) {
        switch(nastroj) {
          case 0:
            pomb = new TElementBod(mx[0], my[0], mbarva[0]);
            elem = (TElement *)pomb;
            elementy->Pridej((TElement *)pomb);
            pomb->SetSirka(msize);
            break;
          case 1:
            pom = new TElementCara(mx, my, mbarva);
            elem = (TElement *)pom;
            elementy->Pridej((TElement *)pom);
            pom->SetSirka(msize);
            break;
          case 2:
            pomt = new TElementTrojuhelnik(mx, my, mbarva);
            elem = (TElement *)pomt;
            elementy->Pridej((TElement *)pomt);
            pomt->SetVyplneny(mfill);
            break;
          case 3:
            mx[1] = mx[1] - mx[0];
            my[1] = my[1] - my[0];
            pomo = new TElementObdelnik(mx, my, mbarva);
            elem = (TElement *)pomo;
            elementy->Pridej((TElement *)pomo);
            pomo->SetVyplneny(mfill);
            break;
        };
        bpocet = -1; bpos = -1;
      };
      break;

    default:
      break;
  };
};
//------------------------------------------------------------------------------

void NactiKonfiguraci() {
  FILE *soubor;
  char jmeno[]="../mgldraw/mgldraw.ini";

  //otevreni souboru
  soubor = fopen(jmeno, "rt");
  if (!soubor)
    return;

  fscanf(soubor, "%i %i %i %i %i", &obrx, &obry, &fullscr, &virtx, &virty);

  // uzavreni souboru
  fclose(soubor);
  return;
};
//------------------------------------------------------------------------------

// main
int main(int argc, char **argv) {
//WINAPI WinMain( HINSTANCE hInst1, HINSTANCE hInst2, LPSTR lpStr, int anInt ) {

  // **** nacteni konfigurace {
  NactiKonfiguraci();

  (fullscr) ? mglOpenFullscreen("MGLDraw 1.0") :
     mglOpenWindow ("MGLDraw", 0, 0, obrx, obry);

  oknoFps->SetX(mglVirtualWidth-100);
  oknoXY->SetX(mglVirtualWidth-100);
  oknoXY->SetY(mglVirtualHeight-50);

  oknoNastroj->SetY(mglVirtualHeight-110);

  oknoEdit->SetY(mglVirtualHeight-170);

  oknoPaleta->SetX(mglVirtualWidth-108);
  oknoPaleta->SetY(mglVirtualHeight-170);

  mainFont = mglLoadFont("../data/fonts/default.txt", "../data/fonts/default.tga");

  mouseImg = mglLoadTexture ("../data/mouse/mouse.tga", 2, GL_LINEAR);

  mglSetDisplayHandler(ZobrazovaciFce);
  mglSetMouseHandler(ObsluhaMysi);
  mglSetKeyboardHandler(HandlovaniKlaves);

  elementy = new TSeznam<TElement>();

  ovladani = new TSeznam<TView>();

  ovladani->Pridej((TView *)oknoFps);
  ovladani->Pridej((TView *)oknoXY);
  ovladani->Pridej((TView *)oknoInfo);
  ovladani->Pridej((TView *)oknoNastroj);
  ovladani->Pridej((TView *)oknoEdit);
  ovladani->Pridej((TView *)oknoPaleta);

    mglRun ();

  delete elementy;

  delete oknoFps;
  delete ovladani;

  return 0;
}
//------------------------------------------------------------------------------



