//---------------------------------------------------------------------------
#ifndef seznamH
#define seznamH
//---------------------------------------------------------------------------

/// seznam pointru uvedeneho typu
template <class T>
class TSeznam {
  private:
    class TPrvek {
      public:
        T *data;
        TPrvek *dalsi;
        TPrvek(T *adata) { data = adata; dalsi = NULL;};
    };
    /// vlastni seznam dat
    TPrvek *hlava;
    TPrvek *aktualni;

  public:
    /// konstruktor - vytvori prazdny seznam
    TSeznam();

    /**
     Vlozi prvek na konec seznamu
     @param prvek  vkladany prvek
     @return       true pokud byl prvek vlozen
    */
    bool Pridej(T *prvek);

    /**
     Vlozi prvek za uvedeny prvekv seznamu
     @param kam    prvek za ktery vkladame
     @param prvek  vkladany prvek
     @return       true pokud byl prvek vlozen
    */
    bool PridejZa(T *kam, T *prvek);

    /**
     Odebere prvek ze seznamu
     @param prvek  odebirany prvek
     @return       true pokud byl prvek odebran
    */
    bool Odeber(T *prvek);

    /**
     Test, jestli je seznam prazdny
     @return       true pokud je prazdny
    */
    bool JePrazdny();

    /**
     Vrati pocet prvku seznamu
     @return       pocet prvku
    */
    int PocetPrvku();

    T *DejPrvek(int cislo);

    void NaZacatek();

    void Posun();

    T *CtiPrvek();

    T *DalsiPrvek(T* odkud);

    T *PredchoziPrvek(T* odkud);

    /// destruktor - vyprazdni seznam
    ~TSeznam();
};
//---------------------------------------------------------------------------
#endif
